; $Id: setup.iss 629 2011-08-07 18:54:53Z elbereth $
;
; The contents of this file are subject to the Mozilla Public License
; Version 1.1 (the "License"); you may not use this file except in compliance
; with the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
;
; Software distributed under the License is distributed on an "AS IS" basis,
; WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
; specific language governing rights and limitations under the License.
;
; The Original Code is setup.iss, released May 8, 2004.
;
; The Initial Developer of the Original Code is Alexandre Devilliers
; (elbereth@users.sourceforge.net, http://www.elberethzone.net).

[Setup]
Compression=lzma2/ultra64
LZMAUseSeparateProcess=yes
SolidCompression=true
AppName=Dragon UnPACKer 5
AppVerName=Dragon UnPACKer v5.6.2 Exedra-Chac (stable)
AppPublisher=Alexandre Devilliers (aka Elbereth)
AppPublisherURL=http://www.elberethzone.net
AppSupportURL=http://www.elberethzone.net/dup-support.html
AppUpdatesURL=http://www.dragonunpacker.com
AppCopyright=Mozilla Public License 1.1
DefaultDirName={pf}\Dragon UnPACKer 5
DefaultGroupName=Dragon UnPACKer 5
OutputBaseFilename=dup562exedrachac-setup
AppMutex=DragonUnPACKer5
AppId=DragonUnPACKer5
DisableStartupPrompt=true
UninstallDisplayName=Dragon UnPACKer 5
UninstallDisplayIcon={app}\drgunpack5.exe
WizardImageBackColor=$ffffff
WizardImageFile=dup5-instimage.bmp
WizardSmallImageFile=dup5-inst55x55.bmp
VersionInfoVersion=5.6.2
MinVersion=4.10,4.0sp6
LicenseFile=..\docs\core\source\LICENCE.txt
InternalCompressLevel=ultra64
VersionInfoDescription=Dragon UnPACKer 5 Setup
VersionInfoTextVersion=5.6.2 Exedra-Chac
VersionInfoCopyright=Elbereth / MPL 1.1
VersionInfoProductName=Dragon UnPACKer
VersionInfoProductVersion=5.6.2
AppVersion=5.6.2 Exedra Chac
SetupIconFile=..\tools\duppi\duppi.ico
AppReadmeFile={app}\readme.txt

[Languages]
Name: en; MessagesFile: compiler:Default.isl; InfoBeforeFile: setup-info-english.rtf
Name: sp; MessagesFile: compiler:languages\Spanish.isl; InfoBeforeFile: setup-info-spanish.rtf
Name: fr; MessagesFile: compiler:languages\French.isl; InfoBeforeFile: setup-info-french.rtf

[Tasks]
Name: desktopicon; Languages: en; Description: Create a &desktop icon; GroupDescription: Additional icons:; MinVersion: 4,4
Name: quicklaunchicon; Languages: en; Description: Create a &Quick Launch icon; GroupDescription: Additional icons:; MinVersion: 4,4; Flags: unchecked
Name: desktopicon; Languages: fr; Description: Placer une icone sur le bureau; GroupDescription: Icones supplmentaires:; MinVersion: 4,4
Name: quicklaunchicon; Languages: fr; Description: Placer une icone sur la barre de lancement rapide; GroupDescription: Icones supplmentaires:; MinVersion: 4,4; Flags: unchecked
Name: desktopicon; Languages: sp; Description: Poner un icono sobre el desktop; GroupDescription: Iconos adicionales:; MinVersion: 4,4
Name: quicklaunchicon; Languages: sp; Description: Poner un icono en la bara de lanzamiento rapido; GroupDescription: Iconos adicionales:; MinVersion: 4,4; Flags: unchecked
Name: deleteoldhrplugins; Description: Remove old useless plugins; GroupDescription: Update from previous versions; Flags: checkedonce; Languages: en
Name: deleteoldhrplugins; Description: Supprimer les anciennes extensions inutiles; GroupDescription: Mise  jour depuis une ancienne version; Flags: checkedonce; Languages: fr
Name: deleteoldhrplugins; Description: Borrar las antiguas versiones de las extenciones; GroupDescription: Antiguas versiones; Flags: checkedonce; Languages: sp

[Files]
Source: ..\..\..\dup-dev-5.1-compiled\drgunpack5.exe; DestDir: {app}; Flags: ignoreversion
Source: ..\..\..\dup-dev-5.1-compiled\drgunpack5.exe.sig; DestDir: {app}; Flags: ignoreversion
Source: ..\..\..\dup-dev-5.1-compiled\data\*.*; DestDir: {app}\data; Flags: ignoreversion
Source: ..\..\..\dup-dev-5.1-compiled\data\drivers\*.*; DestDir: {app}\data\drivers; Flags: ignoreversion
Source: ..\..\..\dup-dev-5.1-compiled\data\convert\*.*; DestDir: {app}\data\convert; Flags: ignoreversion
Source: ..\..\..\dup-dev-5.1-compiled\utils\*.*; DestDir: {app}\utils; Flags: ignoreversion
Source: ..\..\..\dup-dev-5.1-compiled\utils\data\*.*; DestDir: {app}\utils\data; Flags: ignoreversion
Source: ..\..\..\dup-dev-5.1-compiled\utils\templates\*.*; DestDir: {app}\utils\templates\; Flags: ignoreversion
Source: ..\..\..\dup-dev-5.1-compiled\utils\translation\*.*; DestDir: {app}\utils\translation\; Flags: ignoreversion
Source: ..\..\..\dup-dev-5.1-compiled\file_id.diz; DestDir: {app}; Flags: ignoreversion
Source: ..\..\..\dup-dev-5.1-compiled\historique.txt; DestDir: {app}; Flags: ignoreversion
Source: ..\..\..\dup-dev-5.1-compiled\lisezmoi.txt; DestDir: {app}; Flags: ignoreversion
Source: ..\..\..\dup-dev-5.1-compiled\readme.txt; DestDir: {app}; Flags: ignoreversion
Source: ..\..\..\dup-dev-5.1-compiled\whatsnew.txt; DestDir: {app}; Flags: ignoreversion
; For WIP versions
;Source: "E:\Developpement\dup-dev-5.1-compiled\readme-WIP.txt"; DestDir: "{app}"; Flags: ignoreversion

[INI]
Filename: {app}\DrgUnPack5.url; Section: InternetShortcut; Key: URL; String: http://www.dragonunpacker.com

[Icons]
Name: {group}\Dragon UnPACKer 5; Filename: {app}\DrgUnPack5.exe
; vvv --- sp --- vvv
Name: {group}\Read me; Languages: en sp; Filename: {app}\readme.txt
; For WIP versions
;Name: "{group}\Read me (Unstable releases)"; Languages: en; Filename: "{app}\readme-WIP.txt"
;Name: "{group}\Lisez moi (version instable) [Anglais]"; Languages: fr; Filename: "{app}\readme-WIP.txt"
Name: {group}\Lisez moi; Languages: fr; Filename: {app}\lisezmoi.txt
; vvv --- sp --- vvv
Name: {group}\What's new; Languages: en sp; Filename: {app}\whatsnew.txt
Name: {group}\Historique des versions; Languages: fr; Filename: {app}\historique.txt
Name: {group}\Dragon UnPACKer 5 on the Web; Languages: en; Filename: {app}\DrgUnPack5.url
Name: {group}\Dragon UnPACKer 5 sur le Web; Languages: fr; Filename: {app}\DrgUnPack5.url
Name: {group}\Dragon UnPACKer 5 sobre la Red; Languages: sp; Filename: {app}\DrgUnPack5.url
Name: {group}\Duppi (Package installer & Internet update); Languages: en; Filename: {app}\utils\Duppi.exe
Name: {group}\Duppi (Installation de packets et mise  jour via Internet); Languages: fr; Filename: {app}\utils\Duppi.exe
Name: {group}\Duppi (Instalador de paquetes y puestas al dia por Internet); Languages: sp; Filename: {app}\utils\Duppi.exe
Name: {userdesktop}\Dragon UnPACKer 5; Filename: {app}\DrgUnPack5.exe; MinVersion: 4,4; Tasks: desktopicon
Name: {userappdata}\Microsoft\Internet Explorer\Quick Launch\Dragon UnPACKer 5; Filename: {app}\DrgUnPack5.exe; MinVersion: 4,4; Tasks: quicklaunchicon
Name: {group}\Uninstall; Filename: {uninstallexe}

[Run]
Languages: en; Filename: {app}\DrgUnPack5.exe; Parameters: /lng; Description: Launch Dragon UnPACKer 5 to finish installation; Flags: nowait postinstall skipifsilent
Languages: fr; Filename: {app}\DrgUnPack5.exe; Parameters: /lng; Description: Lancer Dragon UnPACKer 5 pour finir l'installation; Flags: nowait postinstall skipifsilent
Languages: sp; Filename: {app}\DrgUnPack5.exe; Parameters: /lng; Description: Lanzar Dragon UnPACKer 5 para terminar la instalacion; Flags: nowait postinstall skipifsilent

[UninstallDelete]
Type: files; Name: {app}\DrgUnPack5.url

[InstallDelete]
Name: {app}\data\drivers\drv_mix.d5d; Type: files; Tasks: 
Name: {app}\data\drivers\drv_giants.d5d; Type: files; Tasks: 
Name: {app}\data\HyperRipper\*.d5h; Type: files; Tasks: 
Name: {app}\data\HyperRipper; Type: dirifempty; Tasks: 

[Registry]
Root: HKCR; SubKey: DUP5.Files; ValueData: ""; Flags: UninsDeleteKey DeleteKey;
Root: HKCR; SubKey: DUP5.Packages; ValueData: ""; Flags: UninsDeleteKey DeleteKey;
Root: HKCU; SubKey: Software\Dragon Software\Dragon UnPACKer 5; ValueData: ""; Flags: UninsDeleteValue;
Root: HKCU; SubKey: Software\Dragon Software; ValueData: ""; Flags: UninsDeleteKeyIfEmpty; 
